unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtDlgs,
  Generics.Collections, System.Diagnostics, System.IniFiles;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Memo1: TMemo;
    Button3: TButton;
    OpenTextFileDialog1: TOpenTextFileDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  reader: TStreamReader;
  writer: TStreamWriter;
  dt: TDictionary<string, Integer>;
  key: string;
  la: String;
  wa: TStopwatch;
begin
  wa := TStopwatch.Create;
  reader := TStreamReader.Create(Edit1.Text, TEncoding.UTF8, True, 1024);
  dt := TDictionary<string, Integer>.Create();
  Memo1.Lines.Add('--Start--');
  wa.Start;
  {
    repeat
    key := reader.ReadLine;
    if key = '' then
    Break;
    if not dt.ContainsKey(key) then
    begin
    dt.Add(key, 1);
    end;
    until key = '';
  }
  while not reader.EndOfStream do
  begin
    key := reader.ReadLine;
    if not dt.ContainsKey(key) then
    begin
      dt.Add(key, 1);
    end;
  end;

  reader.Close;
  Memo1.Lines.Add('--OutPut--');
  Memo1.Lines.Add(wa.ElapsedMilliseconds.ToString);

  writer := TStreamWriter.Create(GetCurrentDir + '\Outdata.txt');
  for la in dt.Keys do
  begin
    writer.WriteLine(la);
  end;
  dt.Clear;
  writer.Close;
  Memo1.Lines.Add('--Over--');
  reader.Free;
  writer.Free;
  dt.Free;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if OpenTextFileDialog1.Execute then
  begin
    Edit1.Text := OpenTextFileDialog1.FileName;
  end;
end;

end.
